package com.fp.persistence.pgeneral.acco;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import java.sql.Timestamp;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEACCOUNTREMITTANCEHOLD*/
@Entity(name="TgeneAccountRemittanceHold")
@Table(name="TGENEACCOUNTREMITTANCEHOLD")
public class TgeneAccountRemittanceHold extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneAccountRemittanceHold
*/
@EmbeddedId
private TgeneAccountRemittanceHoldKey pk;
@Column(name="REMITTANCENUMBER", nullable=true)

/**
* Numero de carta remesa
*/
private String remittancenumber;

@Column(name="OFFICECODE", nullable=true)

/**
* Codigo de oficina
*/
private Integer officecode;

@Column(name="BRANCHCODE", nullable=true)

/**
* Codigo de sucursal
*/
private Integer branchcode;

@Column(name="ACCOUNTINGDATE", nullable=true)

/**
* Fecha contable con la cual se crea el registro de cheques locales
*/
private Date accountingdate;

@Column(name="OWNACCOUNT", nullable=true)

/**
* Numero de cuenta duenia del cheque
*/
private String ownaccount;

@Column(name="CHECKNUMBER", nullable=true)

/**
* Numero de cheque
*/
private Integer checknumber;

@Column(name="CHECKVALUE", nullable=true)

/**
* Valor del cheque,  si no existe numero de cheque y el deposito se recibe cheque es el valor total de cheques.
*/
private BigDecimal checkvalue;

@Column(name="TRANSITROUTE", nullable=true)

/**
* Codigo de ruta transito asociada al cheque
*/
private String transitroute;

@Column(name="DATETORELEASE", nullable=true)

/**
* Fecha en la que se tiene que confirma los fondos en la cuenta depositada.
*/
private Date datetorelease;

@Column(name="RELEASE", nullable=true)

/**
* Y indica que el cheque esta confirmado.
*/
private String release;

@Column(name="RELEASEDATE", nullable=true)

/**
* Fecha de confirmacion de fondos en la cuenta depositada
*/
private Date releasedate;

@Column(name="RETURNED", nullable=true)

/**
* Indica, si el cheque esta devuelto.
*/
private String returned;

@Column(name="RETURNEDDATE", nullable=true)

/**
* Fecha en la que se devolvio el cheque.
*/
private Date returneddate;

@Column(name="JOURNALID", nullable=true)

/**
* Numero de mensaje con el que se registra los datos del cheque
*/
private String journalid;

/**Contructor por defecto*/
public TgeneAccountRemittanceHold(){
}
/**Contructor de TgeneAccountRemittanceHold
@param pPk Clave Primaria del entity
*/
public TgeneAccountRemittanceHold(TgeneAccountRemittanceHoldKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneAccountRemittanceHold
*/
public static TgeneAccountRemittanceHold find(EntityManager pEntityManager,TgeneAccountRemittanceHoldKey pKey) throws Exception{
    TgeneAccountRemittanceHold obj = pEntityManager.find(TgeneAccountRemittanceHold.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneAccountRemittanceHold
@return El objeto que referencia a la Clave primaria de TgeneAccountRemittanceHold
*/
public TgeneAccountRemittanceHoldKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneAccountRemittanceHold
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneAccountRemittanceHold
*/
public void setPk(TgeneAccountRemittanceHoldKey pPk){
  pk=pPk;
}
/**Obtiene el valor de remittancenumber
@return valor de remittancenumber*/
public String getRemittancenumber(){
  return remittancenumber;
}
/**Fija el valor de remittancenumber
@param pRemittancenumber nuevo Valor de remittancenumber*/
public void setRemittancenumber(String pRemittancenumber){
  remittancenumber=pRemittancenumber;
}

/**Obtiene el valor de officecode
@return valor de officecode*/
public Integer getOfficecode(){
  return officecode;
}
/**Fija el valor de officecode
@param pOfficecode nuevo Valor de officecode*/
public void setOfficecode(Integer pOfficecode){
  officecode=pOfficecode;
}

/**Obtiene el valor de branchcode
@return valor de branchcode*/
public Integer getBranchcode(){
  return branchcode;
}
/**Fija el valor de branchcode
@param pBranchcode nuevo Valor de branchcode*/
public void setBranchcode(Integer pBranchcode){
  branchcode=pBranchcode;
}

/**Obtiene el valor de accountingdate
@return valor de accountingdate*/
public Date getAccountingdate(){
  return accountingdate;
}
/**Fija el valor de accountingdate
@param pAccountingdate nuevo Valor de accountingdate*/
public void setAccountingdate(Date pAccountingdate){
  accountingdate=pAccountingdate;
}

/**Obtiene el valor de ownaccount
@return valor de ownaccount*/
public String getOwnaccount(){
  return ownaccount;
}
/**Fija el valor de ownaccount
@param pOwnaccount nuevo Valor de ownaccount*/
public void setOwnaccount(String pOwnaccount){
  ownaccount=pOwnaccount;
}

/**Obtiene el valor de checknumber
@return valor de checknumber*/
public Integer getChecknumber(){
  return checknumber;
}
/**Fija el valor de checknumber
@param pChecknumber nuevo Valor de checknumber*/
public void setChecknumber(Integer pChecknumber){
  checknumber=pChecknumber;
}

/**Obtiene el valor de checkvalue
@return valor de checkvalue*/
public BigDecimal getCheckvalue(){
  return checkvalue;
}
/**Fija el valor de checkvalue
@param pCheckvalue nuevo Valor de checkvalue*/
public void setCheckvalue(BigDecimal pCheckvalue){
  checkvalue=pCheckvalue;
}

/**Obtiene el valor de transitroute
@return valor de transitroute*/
public String getTransitroute(){
  return transitroute;
}
/**Fija el valor de transitroute
@param pTransitroute nuevo Valor de transitroute*/
public void setTransitroute(String pTransitroute){
  transitroute=pTransitroute;
}

/**Obtiene el valor de datetorelease
@return valor de datetorelease*/
public Date getDatetorelease(){
  return datetorelease;
}
/**Fija el valor de datetorelease
@param pDatetorelease nuevo Valor de datetorelease*/
public void setDatetorelease(Date pDatetorelease){
  datetorelease=pDatetorelease;
}

/**Obtiene el valor de release
@return valor de release*/
public String getRelease(){
  return release;
}
/**Fija el valor de release
@param pRelease nuevo Valor de release*/
public void setRelease(String pRelease){
  release=pRelease;
}

/**Obtiene el valor de releasedate
@return valor de releasedate*/
public Date getReleasedate(){
  return releasedate;
}
/**Fija el valor de releasedate
@param pReleasedate nuevo Valor de releasedate*/
public void setReleasedate(Date pReleasedate){
  releasedate=pReleasedate;
}

/**Obtiene el valor de returned
@return valor de returned*/
public String getReturned(){
  return returned;
}
/**Fija el valor de returned
@param pReturned nuevo Valor de returned*/
public void setReturned(String pReturned){
  returned=pReturned;
}

/**Obtiene el valor de returneddate
@return valor de returneddate*/
public Date getReturneddate(){
  return returneddate;
}
/**Fija el valor de returneddate
@param pReturneddate nuevo Valor de returneddate*/
public void setReturneddate(Date pReturneddate){
  returneddate=pReturneddate;
}

/**Obtiene el valor de journalid
@return valor de journalid*/
public String getJournalid(){
  return journalid;
}
/**Fija el valor de journalid
@param pJournalid nuevo Valor de journalid*/
public void setJournalid(String pJournalid){
  journalid=pJournalid;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneAccountRemittanceHold))return false;
    TgeneAccountRemittanceHold that = (TgeneAccountRemittanceHold) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneAccountRemittanceHold
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneAccountRemittanceHold
*/
public Object createInstance(){
 TgeneAccountRemittanceHold instance=new TgeneAccountRemittanceHold();	
 instance.setPk(new TgeneAccountRemittanceHoldKey());
 return instance;
}
/**Clona la entidad TgeneAccountRemittanceHold
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneAccountRemittanceHold p=(TgeneAccountRemittanceHold)this.clone();
  p.setPk((TgeneAccountRemittanceHoldKey)this.pk.cloneMe());
  return p;
}
}
